TopCoder SRM 717 Div2 C.DerangementsDiv2[数论][容斥原理][错排]

题意:从1到n+m的数组中选m个数字且每个数字和在原数组中下标不同,求方案数。例如 n=1 m = 2 则存在{2,1},{2,3},{3,1}

题解:错排问题模板 下面是使用容斥原理推导的过程

1. 先推导标准的错排公式 假设为从1到m的m个数字组成的数组

令k=非错排的数字个数 共有m!种情况,需要减去非错排的所有情况。例如减去k=1时则有m个情况(位置为1,2...m的数字不是错排)方案数为$C_{\text{m}}^1 \times ({\text{m - 1)!}}$,以此类推因为容斥原理添加k=2时方案数为$C_{\text{m}}^2 \times ({\text{m - 2)!}}$

则错排的方案数为${\text{m}}! - \sum\limits_{k = 1}^m {{{( - 1)}^k}C_{\text{m}}^k \times ({\text{m - k)!}}} $

2.在题目中 方程应改为 ${\text{(m + n)}}! - \sum\limits_{k = 1}^m {{{( - 1)}^k}C_{\text{m}}^k \times ({\text{n + m - k)!}}}$

(m+n)!全排列方案数 减去前m个存在的所有错排方案数。

代码:

 1 #define _CRT_SECURE_NO_DEPRECATE
 2 #pragma comment(linker, "/STACK:102400000,102400000")
 3 #include<iostream>
 4 #include<cstdio>
 5 #include<fstream>
 6 #include<iomanip>
 7 #include<algorithm>
 8 #include<cmath>
 9 #include<deque>
10 #include<vector>
11 #include<bitset>
12 #include<queue>
13 #include<string>
14 #include<cstring>
15 #include<map>
16 #include<stack>
17 #include<set>
18 #include<functional>
19 #define pii pair<int, int>
20 #define mod 1000000007
21 #define mp make_pair
22 #define pi acos(-1)
23 #define eps 0.00000001
24 #define mst(a,i) memset(a,i,sizeof(a))
25 #define all(n) n.begin(),n.end()
26 #define lson(x) ((x<<1))
27 #define rson(x) ((x<<1)|1)
28 #define inf 0x3f3f3f3f
29 typedef long long ll;
30 typedef unsigned long long ull;
31 using namespace std;
32
33 const int maxn = 55;
34 class DerangementsDiv2 {
35 public:
36     ll c[maxn][maxn];
37     ll fac[170];
38     int count(int n, int m)
39     {
40         mst(c, 0);
41         mst(fac, 0);
42         fac[0] = 1;
43         for (int i = 1; i <= 150; ++i)
44             fac[i] = (fac[i - 1] * (ll)i) % mod;
45         c[0][0] = 1;
46         for (int i = 1; i <= 53; ++i)
47         {
48             c[i][0] = 1;
49             for (int j = 1; j <= i; ++j)
50                 c[i][j] = (c[i - 1][j - 1] + c[i - 1][j]) % mod;
51         }
52         ll ans = fac[n + m];
53         ll cas = -1;
54         for (int i = 1; i <= m; ++i)
55         {
56             ans = (ans + ((cas*fac[n + m - i] * c[m][i]) % mod) + mod) % mod;
57             cas *= -1;
58         }
59
60         return ans;
61     }
62 };
时间: 2024-10-09 21:51:49

TopCoder SRM 717 Div2 C.DerangementsDiv2[数论][容斥原理][错排]的相关文章

topcoder SRM 618 DIV2 WritingWords

只需要对word遍历一遍即可 int write(string word) { int cnt = 0; for(int i = 0 ; i < word.length(); ++ i){ cnt+=word[i]-'A'+1; } return cnt; } topcoder SRM 618 DIV2 WritingWords,布布扣,bubuko.com

topcoder SRM 618 DIV2 MovingRooksDiv2

一开始Y1,Y2两个参数看不懂,再看一遍题目后才知道,vector<int>索引代表是行数,值代表的是列 此题数据量不大,直接深度搜索即可 注意这里深度搜索的访问标识不是以前的索引和元素,而是一个交换元素后的整个状态vector<int>,这样可以避免重复元素的搜索 set<vector<int> > visit; bool flag; void dfs(vector<int>& src, vector<int>& d

topcoder SRM 618 DIV2 LongWordsDiv2

此题给出的条件是: (1)word的每个字母都是大写字母(此条件可以忽略,题目给的输入都是大写字母) (2) 相等字符不能连续,即不能出现AABC的连续相同的情况 (3)word中不存在字母组成xyxy的形式,即不存在第一个字符和第3个字符相等同时第2个字符和第4个字符相等的情况 对于第(2)种情况,只需要考虑word[i]!=word[i-1]即可 对于第(3)种情况,用一个4重循环遍历每种可能的情况,然后第一个字符和第3个字符相等同时第2个字符和第4个字符相等,则输出“DisLikes”即可

TOPCODER SRM 686 div2 1000

// TOPCODER SRM 686 div2 1000 Problem Statement 给出一个至多长 100 的字符串,仅包含 ( 和 ),问其中有多少个不重复的,合法的括号子序列. 子序列可以不连续:合法即括号序列的合法:答案模 1,000,000,007. Examples "(())(" Returns: 2 Correct non-empty bracket subsequences are "()" and "(())". &

topcoder srm 628 div2 250 500

做了一道题,对了,但是还是掉分了. 第二道题也做了,但是没有交上,不知道对错. 后来交上以后发现少判断了一个条件,改过之后就对了. 第一道题爆搜的,有点麻烦了,其实几行代码就行. 250贴代码: 1 #include <iostream> 2 #include <cstring> 3 #include <queue> 4 #include <cmath> 5 #include <cstdio> 6 #include <algorithm&g

topcoder SRM 619 DIV2 GoodCompanyDivTwo

注意题目给的最后一句话,如果部门任何employee都做不同类型的工作,则这个部门是一个diverse,题目是计算department的diverse数 读起来感觉有点别扭,英语没学好的原因 int countGood(vector <int> superior, vector <int> workType) { int res = 0; for(int i = 0 ; i < superior.size(); ++ i){ set<int> department

Topcoder SRM 619 DIv2 500 --又是耻辱的一题

这题明明是一个简单的类似约瑟夫环的问题,但是由于细节问题迟迟不能得到正确结果,结果比赛完几分钟才改对..耻辱. 代码: #include <iostream> #include <cstdio> #include <cstring> #include <cmath> #include <algorithm> #define ll long long using namespace std; #define NN 370000 class Choo

Topcoder SRM 648 Div2 1000

Problem 给一个长度为N的字符串S,S只含有'A'.'B'.'C'三种元素.给定一个K,要求返回字符串S,使得S中恰好有K对pair(i,j)满足 0=<i<j<N,且 S[i]<S[j].若不存在,则返回空串. Limits Time Limit(ms): 2000 Memory Limit(MB): 256 N: [3, 30] K: [0, N*(N-1)/2 ] Solution 设S中含有n1个'A',n2个'B',n3个'C',设num=n1*n2+n1*n3+n

topcoder SRM 522 DIV2 BoxesDiv2

注意题目这句话,Once you have each type of candies in a box, you want to pack those boxes into larger boxes, until only one box remains. 两个box合并后必须放入更大一个盒子 题目的有点类似huffman的前部分,此题用堆去做,由于priority_queue是用堆实现的,故可以直接使用 每次从堆中选取最小的两个进行合并即可 #include <iostream> #incl